#include "malloc.h"

void *malloc_tiny(size_t size) {
	// TODO check if zone still has size and expand zone if needed
	t_block **head = &(g_zones.tiny_zones->head);
	if (*head == NULL) {
		// TODO size_t should be replaced by char * for pointer arithmetic
		size_t addr = ((size_t)g_zones.tiny_zones + sizeof(t_zone));
		printf("addr %zu\n", addr);
		if ((addr + sizeof(t_block)) % 16 != 0) {
			addr += 16 - ((addr + sizeof(t_block)) % 16);
		}
		printf("addr %zu\n", addr);
		*head = (t_block *)addr;
		printf("addr of g_zones.tiny_zones : %p\n \
				addr of *head %p\n \
				sizeof tzone : %zu\n \
				size of tblock %zu\n",
				g_zones.tiny_zones,
				*head,
				sizeof(t_zone),
				sizeof(t_block));
		(*head)->size = size;
		(*head)->free = 0;
		(*head)->next = NULL;
		return (void *)((char *)(*head) + sizeof(t_block));
	}
	else {
		t_block *curr = *head;
		while (curr->next) {
			// todo check if free and defrag
			curr = curr->next;
		}
		printf("addr of curr %p\n \
				curr->size %zu\n", curr, curr->size);
		// TODO size_t should be replaced by char * for pointer arithmetic
		size_t addr = (size_t)curr + sizeof(t_block) + curr->size;
		printf("addr %zu\n", addr);
		if ((addr + sizeof(t_block)) % 16 != 0) {
			addr += 16 - ((addr + sizeof(t_block)) % 16);
		}
		printf("addr %zu\n", addr);
		curr->next = (t_block *)addr;
		curr = curr->next;
		printf("addr of curr %p\n", curr);
		curr->size = size;
		curr->free = 0;
		curr->next = NULL;
		return (void *)((char *)curr + sizeof(t_block));
	}
	return NULL;
}

void *malloc_small(size_t size) {
	(void)size;
	return NULL;
}

void *malloc_large(size_t size) {
	(void)size;
	return NULL;
}

void *ft_malloc(size_t size) {
	pthread_mutex_lock(&g_malloc_mutex);
	void *ptr = NULL;
	if (size < g_zones.tiny_block_max_size) {
		printf("entering malloc_tiny\n");
		ptr = malloc_tiny(size);
	} else if (size < g_zones.small_block_max_size) {
		ptr = malloc_small(size);
	} else {
		ptr = malloc_large(size);
	}
	write(1, "42 from malloc\n", 15);
	pthread_mutex_unlock(&g_malloc_mutex);
	return ptr;
}

